#include <iostream>
#include <fstream>
#include <iomanip>
#include <queue>
#include <string>
#include "queue.cpp"
#include "vector.cpp"
using namespace std;

int solveJosephus(int* allPeople, const int size, const int interval);
void printTemperatures(const char* fileName);

const int N = 41;
const int K = 7;
static int people[N];

int main()
{
	for(int i=0; i < N; ++i)
	{
		people[i] = i;
	}

	const int answer = solveJosephus(people, N, K);

	cout << answer << endl;

	cout << endl;

	printTemperatures("values.txt");

	cout << endl;

	Vector<string> v;

	v.push_back("String 1");
	v.push_back("String 2");
	v.push_back("String 3");
	v.push_back("String 4");
	v.push_back("String 5");

	v.erase(2);
	v.insert(3, "new string");

	for(int i=0; i < v.size(); ++i)
	{
		cout << v.at(i) << endl;
	}

	return 0;

	return 0;
}

struct Temperature {
	int year;
	double value;
};

void print(Buffer<Temperature> buf)
{
	int size = buf.size();

	for(int i=0; i < size; ++i)
	{
		Temperature temp = buf.front();

		cout << temp.year << ": " << fixed << setprecision(1) << temp.value << " degrees\n";

		buf.dequeue();
		buf.enqueue(temp);
	}

	cout << endl;
}

void printTemperatures(const char* fileName) {

	Buffer<Temperature> temps;

	ifstream in(fileName);

	if ( !in.is_open() )
	{
		return;
	}

	while ( !in.eof() )
	{
		Temperature temp;

		in >> temp.year;
		
		if ( in.eof() )
		{
			break;
		}

		double sum = 0;
		const int count = 12;

		for(int i=0; i < count; ++i)
		{
			int value;
			in >> value;
			sum += value;
		}

		if (temp.year == 2009)
		{

		}

		double avg = sum / count;
		temp.value = avg;

		if ( temps.size() >= 10 )
		{
			temps.dequeue();
		}

		temps.enqueue(temp);

		print(temps);
	}
}

int solveJosephus(int* allPeople, const int size, const int interval)
{
	queue<int> people;

	for(int i=0; i < size; ++i)
	{
		people.push(allPeople[i]);
	}

	while ( people.size() > 1 )
	{
		for(int i=0; i < interval - 1; ++i)
		{
			int first = people.front();
			people.pop();
			people.push(first);
		}

		people.pop();
	}

	return people.front();
}